<template>
  <div
    v-click-outside="onBlur"
    class="ob-stepper-container stepper-wrapper"
    :class="{ invalid: invalid, disabled: disabled, readonly: readonly }"
    @click="onFocus"
  >
    <div
      v-if="invalid"
      class="error"
    >
      <ob-tooltip
        v-model="showError"
        position="top-start"
        :content="errorTooltipContent"
        type="error"
      />
    </div>
    <div class="stepper-label">
      {{ label }}
    </div>
    <div class="stepper-chevrons">
      <div
        class="stepper-chevron stepper-chevron-up"
        :class="{ disabled: modelValue >= maxValue }"
        :data-qa="dataQa + '_up'"
        @click="onIncrement"
      >
        <svg
          width="16"
          height="7"
          viewBox="0 0 16 7"
          fill="none"
        >
          <path
            fill="#004BC8"
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M15.0648 6.13799C14.7068 6.39834 14.1264 6.39834 13.7684 6.13799L7.99992 1.94273L2.23143 6.13799C1.87345 6.39834 1.29305 6.39834 0.935072 6.13799C0.57709 5.87764 0.57709 5.45553 0.935072 5.19518L7.35174 0.528513C7.70972 0.268164 8.29012 0.268164 8.6481 0.528513L15.0648 5.19518C15.4227 5.45553 15.4227 5.87764 15.0648 6.13799Z"
          />
        </svg>
      </div>
      <div
        class="stepper-chevron stepper-chevron-down"
        :class="{ disabled: allowNegatives ? false : modelValue <= minValue }"
        :data-qa="dataQa + '_down'"
        @click="onDecrement"
      >
        <svg
          width="16"
          height="7"
          viewBox="0 0 16 7"
          fill="none"
        >
          <path
            fill="#004BC8"
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M0.935233 0.86201C1.29321 0.601661 1.87362 0.601661 2.2316 0.86201L8.00008 5.05727L13.7686 0.862012C14.1265 0.601663 14.7069 0.601663 15.0649 0.862012C15.4229 1.12236 15.4229 1.54447 15.0649 1.80482L8.64826 6.47149C8.29028 6.73184 7.70988 6.73184 7.3519 6.47149L0.935233 1.80482C0.577253 1.54447 0.577253 1.12236 0.935233 0.86201Z"
          />
        </svg>
      </div>
    </div>
    <input
      ref="input"
      v-model="localData"
      data-attr="ob-stepper-container"
      type="number"
      :required="required"
      :allowNegatives="allowNegatives"
      :min="minValue"
      :max="maxValue"
      :step="step"
      :data-qa="dataQa"
      @input="onInput"
      @keydown="onKeydown"
      @paste="onPaste"
    >
  </div>
</template>
<script>
import ClickOutside from 'vue-click-outside'
import obTooltip from '../obTooltip'

export default {
  name: 'ObStepper',
  components: {
    obTooltip
  },
  directives: {
    ClickOutside
  },
  model: {
    prop: 'modelValue',
    event: 'input'
  },
  props: {
    modelValue: {
      type: [String, Number],
      default: () => ''
    },
    minValue: {
      type: [String, Number],
      default: 0
    },
    maxValue: {
      type: [String, Number],
      default: 100
    },
    label: {
      type: String,
      required: true
    },
    step: {
      type: Number,
      default: () => 1
    },
    required: {
      type: Boolean,
      default: () => false
    },
    disabled: {
      type: Boolean,
      default: () => false
    },
    readonly: {
      type: Boolean,
      default: () => false
    },
    allowNegatives: {
      type: Boolean,
      default: () => false
    },
    maxErrorTooltip: {
      type: String,
      default: `Превышено масимальное значение`
    },
    minErrorTooltip: {
      type: String
    },
    requiredErrorTooltip: {
      type: String,
      default: 'Обязательное поле'
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      changed: false,
      localData: '',
      showError: false,
      focused: false
    }
  },
  computed: {
    invalid () {
      return this.invalidRequired || this.invalidMax || this.invalidMin
    },
    invalidRequired () {
      return this.changed && this.required && !this.localData
    },
    invalidMax () {
      return this.localData > this.maxValue
    },
    invalidMin () {
      return this.localData < this.minValue
    },
    errorTooltipContent () {
      if (this.invalidRequired) {
        return this.requiredErrorTooltip
      }
      if (this.invalidMax) {
        return this.maxErrorTooltip
      }
      if (this.invalidMin) {
        return this.minErrorTooltip || `Должно быть не меньше ${this.minValue}`
      }
      return ''
    }
  },
  watch: {
    modelValue: {
      immediate: true,
      handler (val) {
        if (val !== this.localData) {
          this.localData = this.modelValue
        }
      }
    },
    localData: {
      handler: function (newVal) {
        if (this.invalid && this.focused) {
          this.showError = true
        }
      }
    }
  },
  created () {
    this.localData = this.modelValue
  },
  methods: {
    onIncrement () {
      if (this.disabled || this.readonly) return
      if (!this.changed) this.changed = true
      const value = this.modelValue + this.step
      const valueAfterCheck = value > this.maxValue ? this.maxValue : value
      this.localData = valueAfterCheck
      this.$emit('input', valueAfterCheck)
    },
    onDecrement () {
      if (this.disabled || this.readonly) return
      if (!this.changed) this.changed = true
      const value = this.modelValue - this.step
      const valueAfterCheck =
          !this.allowNegatives && value < this.minValue ? this.minValue : value
      this.localData = valueAfterCheck
      this.$emit('input', valueAfterCheck)
    },

    onInput (e) {
      if (!this.changed) this.changed = true
      this.$emit('input', +e.target.value)
    },
    onKeydown (e) {
      if (!this.changed) this.changed = true
      if (
        [46, 8, 9, 27, 13].indexOf(e.keyCode) !== -1 ||
          // Allow: Ctrl+A
          (e.keyCode === 65 && e.ctrlKey === true) ||
          (e.keyCode === 65 && e.metaKey === true) ||
          // Allow: Ctrl+C
          (e.keyCode === 67 && e.ctrlKey === true) ||
          (e.keyCode === 67 && e.metaKey === true) ||
          // Allow: Ctrl+V
          (e.keyCode === 86 && e.ctrlKey === true) ||
          (e.keyCode === 86 && e.metaKey === true) ||
          // Allow: Ctrl+X
          (e.keyCode === 88 && e.ctrlKey === true) ||
          (e.keyCode === 88 && e.metalKey === true) ||
          // Allow: home, end, arrows
          (e.keyCode >= 35 && e.keyCode <= 40) ||
          // props.allowNegative
          ((e.keyCode === 189 || e.keyCode === 173) && this.allowNegatives)
      ) {
        // don't do anything
        return
      }
      // Ensure that it is a number and stop the keypress
      if (
        (e.shiftKey || e.keyCode < 48 || e.keyCode > 57) &&
          (e.keyCode < 96 || e.keyCode > 105)
      ) {
        e.preventDefault()
      }
    },
    onPaste (e) {
      if (!this.changed) this.changed = true
      e.preventDefault()
      const val = e.clipboardData.getData('text/plain')
      if (isNaN(val)) return false
      const num = parseInt(val)
      const res = this.allowNegatives ? num : Math.abs(num)
      if (res < this.minValue || res > this.maxValue) return false
      this.localData = res
      this.$emit('input', res)
    },
    onFocus () {
      if (!this.focused) {
        this.focused = true

        if (this.invalid) {
          this.showError = true
        }

        this.$emit('focus')
      }
    },
    onBlur () {
      if (this.focused) {
        this.focused = false

        if (this.invalid) {
          this.showError = false
        }

        this.$emit('blur')
      }
    }
  }
}
</script>
<style lang="scss" scoped>
$transition-timing: 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
.ob-stepper-container {
  &.stepper-wrapper {
    position: relative;
    width: 100%;

    &.invalid {
      input {
        border-color: $color-error;
      }
    }

    &.disabled {
      pointer-events: none;

      input {
        color: $color-grey-span;
        background: $color-white-lilac;
        border-color: $color-white-lilac;
      }

      .stepper-label {
        color: $color-grey-span;
      }

      path {
        fill: $color-grey-border;
      }
    }

    &.readonly {
      pointer-events: none;

      input {
        background: $color-white-lilac;
        border-color: $color-white-lilac;
      }

      path {
        fill: $color-grey-border;
      }
    }
  }

  .stepper-label {
    position: absolute;
    top: 8px;
    left: 0;
    padding: 0 0 0 12px;
    font-family: "Roboto", sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
    transition: $transition-timing;
    width: calc(100% - 47px);
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }

  .stepper-chevrons {
    position: absolute;
    right: 12px;
    top: 0;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
  }

  .stepper-chevron {
    cursor: pointer;
    transition: opacity $transition-timing;
    user-select: none;
    height: 18px;

    &:hover {
      opacity: 0.75;
    }

    &.disabled {
      pointer-events: none;

      path {
        fill: $color-grey-border;
      }
    }
  }

  input {
    width: 100%;
    height: 52px;
    outline: none;
    box-shadow: none;
    border: 1px solid $color-grey-border;
    border-radius: 3px;
    box-sizing: border-box;
    background: $background-white;
    padding: 24px 38px 8px 11px;
    font-family: "Roboto", sans-serif;
    font-size: 16px;
    line-height: 20px;
    transition: $transition-timing;
    margin: 0;
    appearance: textfield;

    &:focus {
      border-color: $color-blue-navy-blue;
    }

    &::-webkit-outer-spin-button,
    &::-webkit-inner-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }
}

path {
  transition: $transition-timing;
}

.ob-tooltip {
  width: 100%;
}

.error {
  position: absolute;
  top: -13px;
  left: 0;
  width: 100%;
}
</style>
